unit zugferdu;

{$mode objfpc}{$H+}

interface

uses
 Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
 Windows;

type

TCibZugferdSDKEmbed = function(inputPdfFile, inputXmlFile, outputpdfFile : PChar; check : boolean; description: PChar): integer; stdcall;
TCibZugferdSDKIsZugferd = function(PdfFile:PChar):integer; stdcall;
TCibZugferdSDKExtraxt = function(inputPdfFile, outputXmlFile : PChar; check : boolean):integer; stdcall;


{ TForm1 }

TForm1 = class(TForm)
  Button1: TButton;
  Button2: TButton;
  Button3: TButton;
  OpenDialog1: TOpenDialog;
  procedure Button1Click(Sender: TObject);
  procedure Button2Click(Sender: TObject);
  procedure Button3Click(Sender: TObject);
  procedure FormActivate(Sender: TObject);
  procedure FormDestroy(Sender: TObject);
 private
  { private declarations }
 public
  { public declarations }
 end;

var
 Form1: TForm1;
 CibZugferdSDKEmbed: TCibZugferdSDKEmbed;
 CibZugferdSDKIsZugferd: TCibZugferdSDKIsZugferd;
 CibZugferdSDKExtraxt: TCibZugferdSDKExtraxt;
 LibHandle: THandle;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.FormActivate(Sender: TObject);
begin
  LibHandle := LoadLibrary(PChar('CibZugferdSDK32.dll'));
end;

procedure TForm1.Button1Click(Sender: TObject);

 var Err : integer;

begin
 if LibHandle <> 0 then Pointer(CibZugferdSDKEmbed) := GetProcAddress(LibHandle, 'CibZugferdSDKEmbed');
 if @CibZugferdSDKEmbed <> nil then
  begin
   Err := CibZugferdSDKEmbed(PChar('RGPdf.pdf'),PChar('ZUGFeRD-invoice.xml'),PChar('TestPferd.pdf'), false,PChar('TestBeschreibung'));
   ShowMessage(IntToStr(Err));
  end else  ShowMessage('Function ist NIL');
end;

procedure TForm1.Button2Click(Sender: TObject);

 var Err : integer;

begin
 if OpenDialog1.Execute then
  begin
   if LibHandle <> 0 then Pointer(CibZugferdSDKIsZugferd) := GetProcAddress(LibHandle, 'CibZugferdSDKIsZugferd');
   if @CibZugferdSDKIsZugferd <> nil then
    begin
     Err := CibZugferdSDKIsZugferd(PChar(Opendialog1.FileName));
     ShowMessage(IntToStr(Err));
    end else  ShowMessage('Function ist NIL');
  end;
end;

procedure TForm1.Button3Click(Sender: TObject);

 var Err : integer;

begin
 if OpenDialog1.Execute then
  begin
   if LibHandle <> 0 then Pointer(CibZugferdSDKExtraxt) := GetProcAddress(LibHandle, 'CibZugferdSDKExtraxt');
   if @CibZugferdSDKExtraxt <> nil then
    begin
     Err := CibZugferdSDKExtraxt(PChar(Opendialog1.FileName),PChar('Test.xml'),false);
     ShowMessage(IntToStr(Err));
    end else  ShowMessage('Function ist NIL');
  end;

end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  CibZugferdSDKEmbed := nil;
  FreeLibrary(LibHandle);
end;

end.

